
/* std.h */

#ifndef __PROG_STD_H__
#define __PROG_STD_H__

/* assert */

#include <cassert>

/* string */

#include <string>

/* std namespace */

#if __GNUC__ >= 3
   #define GCC3
   using namespace std;
#endif

#ifdef BORLAND
   using namespace std;
#endif

/* hash namespace */

#if __GNUC__ == 2
   #define HASH
   #define HASH_NS
#endif

#if __GNUC__ == 3
   #define HASH
   #define HASH_NS __gnu_cxx::
#endif

#ifdef BORLAND
   #undef HASH
   #undef HASH_NS
#endif

/* namespace */

#define NAMESPACE finch
// modify also cmm/minicpp.g, cmm/txtlex.g, cmm/dirlex.g

#ifdef NAMESPACE
   #define OPEN_NAMESPACE namespace NAMESPACE {
   #define CLOSE_NAMESPACE } // end of namespace
   #define USE_NAMESPACE using namespace NAMESPACE;
#else
   #define OPEN_NAMESPACE
   #define CLOSE_NAMESPACE
   #define USE_NAMESPACE
#endif

#endif /* __PROG_STD_H__ */
